import java.text.SimpleDateFormat;
import javax.portlet.*

import de.ronnyfriedland.AirlineService
import de.ronnyfriedland.Airport
import de.ronnyfriedland.Flight
import de.ronnyfriedland.Plane

class SecondPortlet {

  def title = 'Flight Administration'
  def description = '''
Description about the portlet goes here.
'''
  def displayName = 'Display Name'
  def supports = ['text/html':['view', 'help']]

  // Liferay server specific configurations
  def liferay_display_category = 'MyCategory'
  
  def airlineService
  
  def actionView = {
    
    if(params.save) {
      Flight.withTransaction { status -> 
        
        Flight flight = new Flight()
        
        if(params.date) {
          SimpleDateFormat format = new SimpleDateFormat("M/d/y", Locale.ENGLISH);
          Date date = format.parse(params.date_value);
          flight.date = date
        }
        
        if(params.number) {
          flight.number = params.number
        }
        
        if(params.plane) {
          def plane = Plane.findById(params.plane)
          flight.plane = plane
        }
        
        if(params.start) {
          def start = Airport.findById(params.start)
          flight.start = start
        }
        
        if(params.destination) {
          def destination = Airport.findById(params.destination)
          flight.destination = destination
        }
        
        if(!flight.validate()) {
          flash.error = "Angaben ungültig. Flug konnte nicht gespeichert werden: " + flight.errors
          return
        }
        
        flight.save(flush:true)
        flash.message = "Flug erfolgerich gespeichert."
        return
      }
    }
  }

  def renderView = {
    def airportList = airlineService.listAirports()
    def planeList = airlineService.listPlanes()
    
    ['airportList':airportList, 'planeList':planeList]
  }

  def actionHelp = {
    portletResponse.setPortletMode(PortletMode.VIEW) 
  }

  def renderHelp = {
    def airportList = airlineService.listAirports()
    def planeList = airlineService.listPlanes()
    def flightList = airlineService.listFlights()
    
    ['airportList':airportList, 'planeList':planeList, 'flightList':flightList]
  }
}


/**
 * Form Command Object FlightCommand
 */
class FlightCommand {
  String number
  def date
  Long plane
  Long start
  Long destination
  
  static constraints = {
    number(nullable: false, blank: false, maxSize: 250)
    date(nullable: false)
    plane(nullable: false)
    start(nullable: false)
    destination(nullable: false)
  }
}
